
#ifdef CONSTANTVARIANTS
#define STATICINLINE static inline
#define FNAME(nam) nam##_c
#define BODY
#endif


#ifdef FUNCTIONDEFS
#define STATICINLINE 
#define FNAME(nam) nam
#undef BODY
#endif

#ifdef CODE
#define STATICINLINE 
#define FNAME(nam) nam
#define BODY
#endif


STATICINLINE void FNAME(clr_bit) (unsigned char b)
#ifdef BODY
{
  unsigned char bv;
  bv = ~_BV(b&7);
  b &= ~7;
  switch (b) {
#ifdef PORTA
  case PA:PORTA &= bv;break;
#endif
#ifdef PORTB
  case PB:PORTB &= bv;break;
#endif
#ifdef PORTC
  case PC:PORTC &= bv;break;
#endif
#ifdef PORTD
  case PD:PORTD &= bv;break;
#endif
#ifdef PORTE
  case PE:PORTE &= bv;break;
#endif
#ifdef PORTF
  case PF:PORTF &= bv;break;
#endif
#ifdef PORTG
  case PG:PORTG &= bv;break;
#endif
#ifdef PORTH
  case PH:PORTH &= bv;break;
#endif
  }
}
#else
;
#endif



STATICINLINE void FNAME(set_bit) (unsigned char b)
#ifdef BODY
{
  unsigned char bv;
  bv = _BV(b&7);
  b &= ~7;
  switch (b) {
#ifdef PORTA
  case PA:PORTA |= bv;break;
#endif
#ifdef PORTB
  case PB:PORTB |= bv;break;
#endif
#ifdef PORTC
  case PC:PORTC |= bv;break;
#endif
#ifdef PORTD
  case PD:PORTD |= bv;break;
#endif
#ifdef PORTE
  case PE:PORTE |= bv;break;
#endif
#ifdef PORTF
  case PF:PORTF |= bv;break;
#endif
#ifdef PORTG
  case PG:PORTG |= bv;break;
#endif
#ifdef PORTH
  case PH:PORTH |= bv;break;
#endif
  }
}
#else
;
#endif

STATICINLINE void FNAME(toggle_bit) (unsigned char b)
#ifdef BODY
{
  unsigned char bv;
  bv = _BV(b&7);
  b &= ~7;
  switch (b) {
#ifdef PINA
  case PA:PINA = bv;break;
#endif
#ifdef PINB
  case PB:PINB = bv;break;
#endif
#ifdef PINC
  case PC:PINC = bv;break;
#endif
#ifdef PIND
  case PD:PIND = bv;break;
#endif
#ifdef PINE
  case PE:PINE = bv;break;
#endif
#ifdef PINF
  case PF:PINF = bv;break;
#endif
#ifdef PING
  case PG:PING = bv;break;
#endif
#ifdef PINH
  case PH:PINH = bv;break;
#endif
  }
}
#else
;
#endif


STATICINLINE void FNAME(make_output) (unsigned char b)
#ifdef BODY

{
  unsigned char bv;
  bv = _BV (b&7);
  b &= ~7;
  switch (b) {
#ifdef DDRA
  case PA:DDRA |= bv;break;
#endif
#ifdef DDRB
  case PB:DDRB |= bv;break;
#endif
#ifdef DDRC
  case PC:DDRC |= bv;break;
#endif
#ifdef DDRD
  case PD:DDRD |= bv;break;
#endif
#ifdef DDRE
  case PE:DDRE |= bv;break;
#endif
#ifdef DDRF
  case PF:DDRF |= bv;break;
#endif
#ifdef DDRG
  case PG:DDRG |= bv;break;
#endif
#ifdef DDRH
  case PH:DDRH |= bv;break;
#endif
  }
}
#else
;
#endif


STATICINLINE void FNAME(make_input) (unsigned char b)
#ifdef BODY
{
  unsigned char bv;
  bv = ~_BV (b&7);
  b &= ~7;
  switch (b) {
#ifdef DDRA
  case PA:DDRA &= bv;break;
#endif
#ifdef DDRB
  case PB:DDRB &= bv;break;
#endif
#ifdef DDRC
  case PC:DDRC &= bv;break;
#endif
#ifdef DDRD
  case PD:DDRD &= bv;break;
#endif
#ifdef DDRE
  case PE:DDRE &= bv;break;
#endif
#ifdef DDRF
  case PF:DDRF &= bv;break;
#endif
#ifdef DDRG
  case PG:DDRG &= bv;break;
#endif
#ifdef DDRH
  case PH:DDRH &= bv;break;
#endif
  }
}
#else
;
#endif


STATICINLINE unsigned char  FNAME(get_input) (unsigned char b)
#ifdef BODY
{
  unsigned char iv = 0;
  switch (b & ~7) {
#ifdef PINA
  case PA:iv = PINA;break;
#endif
#ifdef PINB
  case PB:iv = PINB;break;
#endif
#ifdef PINC
  case PC:iv = PINC;break;
#endif
#ifdef PIND
  case PD:iv = PIND;break;
#endif
#ifdef PINE
  case PE:iv = PINE;break;
#endif
#ifdef PINF
  case PF:iv = PINF;break;
#endif
#ifdef PING
  case PG:iv = PING;break;
#endif
#ifdef PINH
  case PH:iv = PINH;break;
#endif
  }
  iv >>= (b&7);
  return iv & 1;
}
#else
;
#endif

 
STATICINLINE void  FNAME(pinMode) (unsigned char b, unsigned char mode)
#ifdef BODY
{
  if (mode) make_output (b);
  else      make_input  (b);
}
#else
;
#endif


STATICINLINE void  FNAME(digitalWrite) (unsigned char b, unsigned char v)
#ifdef BODY
{
  if (v) set_bit (b);
  else   clr_bit (b);
}
#else
;
#endif
 

#if 0
STATICINLINE unsigned char  FNAME(digitalRead) (unsigned char b)
#ifdef BODY
{
  return get_input (b);
}
#else
;
#endif

#else 
#ifdef CONSTANTVARIANTS
#define digitalRead_c FNAME(get_input)
#else
#define digitalRead FNAME(get_input)
#endif
#endif


#undef STATICINLINE
#undef FNAME
#undef BODY
